<SCRIPT LANGUAGE="VBSCRIPT">
' 
' CatchEMail version 2
' Michael B. Smith, michael@briworks.com
' December 2005
'
' CatchEMail version 1
' July 2003
'
' Based on MSKB 324021
' Anyone may use this, if you take the code, make sure you credit me.
' I claim no responsibility - it works for me.
'
Option Explicit
'
' For information about the below namespace, see 
'   http://msdn.microsoft.com/library/default.asp?url=/library/en-us/cdosys/html/55fd620d-b328-4e0d-8f86-15cdd29dbb5a.asp
'
Const RECIP_LIST = "http://schemas.microsoft.com/cdo/smtpenvelope/recipientlist"
'
' For information about the CdoEventStatus enumeration, see 
'   http://msdn.microsoft.com/library/default.asp?url=/library/en-us/cdosys/html/fb9292d8-1da2-432d-901d-fad8ef2dcb40.asp
'
Const CDO_RUN_NEXT_SINK = 0
'
' Domain names of interest
' -- these can be pulled from the Active Directory (Recipient Policies and Internet Message Formats) - but it's slow
'
Dim domains, catchalls
'
' the domains array contains a list of all the domains we are interested in
'
domains = Array (1ZUERSETZENDESFELD1.de)
'
' the catchalls array contains a list of all the catchall addresses
' IN EXACTLY THE SAME ORDER, NONE ADDED, NONE LEFT OUT as the domains array
'
catchalls = Array (1ZUERSETZENDESFELD1.de)
'
' all entries in the two arrays should be in lower case
'
' For Application Event Log entries
'
Const EVENT_SUCCESS = 0
Const EVENT_ERROR   = 1
'
Const bDebug = False
'
Dim varDomainNC		' (String) the domain naming context, will be a string of the form "DC=brnets,DC=int"
Dim StartTime		' (Float) Time the program started
Dim EndTime		' (Float) Time the real work in the program ended
Dim objShell		' (WScript.Shell) Used for logging
Dim Conn		' (ADODB.Connection) Connection to Active Directory
Dim Com			' (ADODB.Command) Active Directory LDAP command
Dim Rs			' (ADODB.Recordset) Result-set from AD LDAP command

Sub IEventIsCacheable_IsCacheable()
	' just returns S_OK
End Sub
'
' OnArrival sink entry point
'
Sub ISMTPOnArrival_OnArrival (ByVal Msg, EventStatus)
	Dim objFields
	Dim strInput
	Dim strOutput

	On Error Resume Next

	If DoSetup () Then
		Set objFields = Msg.EnvelopeFields
		strInput = objFields (RECIP_LIST).Value

		If bDebug Then objShell.LogEvent EVENT_SUCCESS, "Event sink input: '" & strInput & "'"

		If Len (strInput) > 0 Then
			strOutput = FixupRecipientList (strInput)

			objFields (RECIP_LIST).Value = strOutput
			objFields.Update
  
			Msg.DataSource.Save ' Commit changes
		Else
			strOutput = ""
		End If

		If bDebug Then objShell.LogEvent EVENT_SUCCESS, "Event sink output: '" & strOutput & "' time = " & (Timer - StartTime)

		Call DoCleanup ()
	End If

	EventStatus = CDO_RUN_NEXT_SINK
End Sub

Function DoSetup ()
	Dim objRootDSE

	On Error Resume Next
	StartTime = Timer

	DoSetup = True ' everything is OK so far

	Set objRootDSE = GetObject ("LDAP://RootDSE")
	varDomainNC = objRootDSE.Get ("defaultNamingContext")
	Set objRootDSE = Nothing

	Err.Clear
	Set objShell = CreateObject ("WScript.Shell")
	If Err.Number <> 0 Then
		' Can't log an error - don't have any way to!
		DoSetup = False
		Exit Function
	End If

	Err.Clear
	set Conn = CreateObject ("ADODB.Connection")
	If Err.Number <> 0 Then
		objShell.LogEvent EVENT_ERROR, "Conn.Create " & Err.Number & " " & Err.Description
		DoSetup = False
		Set objShell = Nothing
		Exit Function
	End If

	Err.Clear
	set Com  = CreateObject ("ADODB.Command")
	If Err.Number <> 0 Then
		objShell.LogEvent EVENT_ERROR, "Com.Create " & Err.Number & " " & Err.Description
		DoSetup = False
		Set objShell = Nothing
		Set Conn     = Nothing
		Exit Function
	End If

	' Open the connection.
	Conn.Provider = "ADsDSOObject"

	Err.Clear
	Conn.Open "ADsDSOObject"
	If Err.Number <> 0 Then
		objShell.LogEvent EVENT_ERROR, "Conn.Open " & Err.Number & " " & Err.Description
		DoSetup = False
		Set objShell = Nothing
		Set Conn     = Nothing
		Set Com      = Nothing
		Exit Function
	End If
End Function

Sub DoCleanup ()
	Set objShell = Nothing
	Set Com      = Nothing
	Set Conn     = Nothing
End Sub

Function SearchForAddress (ByVal strAddress)
'
' Make an LDAP query for the address. It should have the "SMTP:" in front, but the terminal ';' stripped
'
	Dim strQuery	' As String
	Dim Address	' As String

	SearchForAddress = True ' everything is fine so far

	On Error Resume Next

	strQuery = "<LDAP://" & varDomainNC & ">;(proxyAddresses=" & strAddress & ");userprincipalname"
	If bDebug Then objShell.LogEvent EVENT_SUCCESS, "LDAP Query String: '" & strQuery & "'"

	Com.ActiveConnection = Conn
	Com.CommandText = strQuery

	Err.Clear
	Set Rs = Com.Execute
	If Err.Number <> 0 Then
		objShell.LogEvent EVENT_ERROR, "Com.Execute " & Err.Number & " " & Err.Description
		SearchForAddress = False ' arguably, this should be true
		Exit Function
	End If

	' Iterate through the results.
	While Not Rs.EOF
		' If we get here, the address was found in AD. That's all we care about.
		Rs.Close
		Set Rs = Nothing
		Exit Function
	Wend

	' Done with this LDAP query
	Rs.Close
	Set Rs = Nothing

	' Address of interest was not found in AD
	SearchForAddress = False
End Function

Function SearchDomains (ByVal strDomain)
	Dim strDom, i

	strDom = LCase (strDomain)
	For i = LBound (domains) To UBound (domains)
		If strDom = domains (i) Then
			SearchDomains = i
			Exit Function
		End If
	Next

	SearchDomains = -1
End Function
'
'  Change any unknown email addresses
'
Function FixupRecipientList (strList)
	Dim arr, iUpper, i, j, str

	arr = Split (LCase (strList), ";")
	iUpper = UBound (arr)

	For i = LBound (arr) To iUpper
		str = arr (i)

		j = Instr (str, "@")
		If j > 0 Then
			j = SearchDomains (LCase (Mid (str, j + 1)))
			If j >= 0 Then
				If Not SearchForAddress (str) Then
					str = catchalls (j)
					arr (i) = str
				End If
			End If
		End If
	Next

	FixupRecipientList = Join (arr, ";")
End Function
	'
	' for testing
	'
'	If DoSetup() Then
'		Dim str
'
'		wscript.echo "Setup worked"
'		str = "smtp:a@domain.com;smtp:johnny@brnets.com;smtp:chrisa@microsoft.com;smtp:michael@brnets.com;smtp:sales@wedoexchange.com;smtp:george"
'		wscript.echo "Input string: " & str
'		WScript.echo "Output string: " & FixupRecipientList (str)
'		Call DoCleanup ()
'	Else
'		WScript.Echo "Setup failed"
'	End If
</SCRIPT>