<?php

/****************************************************************************
name:		menu-bench.php
version:	1.0
copyright:	(c) 2005 Carsten Meier

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Lesser General Public
    License as published by the Free Software Foundation; either
    version 2.1 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Lesser General Public License for more details.

    You should have received a copy of the GNU Lesser General Public
    License along with this library; if not, write to the Free Software
    Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

contact:	Carsten Meier
		Under de Diek 19
		D-26757 Borkum
		Germany

homepage:	http://www.trexity.de/webdev/menu-bench.html
e-mail:		cm@trexity.de
****************************************************************************/


// prints a single item

// $item	- array with the keys: 'url', 'title'
// $format	- format string with %1$s for url and %2$s for title
// $printsep	- determines whether the separator should be printed
// $sep		- the separator to print

function menubench_print_item($item, $format, &$printsep, $sep)
{
	if(isset($item) && !empty($format))
	{
		if($printsep)
			print $sep;
		printf($format, $item['url'], $item['title']);
		$printsep = true;
	}
}


// prints start/prev/next/end-links

// $curkey	- the key of the current item in the $items-array
// $items	- array of arrays with the following entries:
//	'url'		- the URL of the item (HTML-encoded)
//	'title'		- the title of the item (HTML-encoded w/o tags)
// $templ	- array with the following entries:
//	'prefix'	- gets printed first
//	'postfix'	- gets printed finally
//	'separator'	- separates links
//	'start'		- format-strings for the corresponding link-types
//	'end'		  with %1$s for the URL and %2$s for the title
//	'next'
//	'prev'


function menubench_navigation($curkey, $items, $templ)
{
	print $templ['prefix'];

	$printsep = false;
	$sep = $templ['separator'];

	// start-link

	reset($items);
	if(($ent = each($items)) && $curkey != $ent[0])
	{
		// current item is not the first one

		menubench_print_item(
			$ent[1], $templ['start'], $printsep, $sep);

		// prev-link

		while($newent = each($items))
		{
			if($curkey==$newent[0])
			{
				menubench_print_item(
					$ent[1], $templ['prev'],
					$printsep, $sep);
				break;
			}
			$ent = $newent;
		}
	}

	// next-link

	if($ent = each($items))
	{
		// current item is not the last one

		menubench_print_item(
			$ent[1], $templ['next'], $printsep, $sep);

		// end-link

		end($items);
		$ent = each($items);
		menubench_print_item(
			$ent[1], $templ['end'], $printsep, $sep);
	}

	print $templ['postfix'];
}


// prints a menu

// $curkey	- the key of the current item in the $items-array
// $items	- array of arrays with the following entries:
//	'url'		- the URL of the item (HTML-encoded)
//	'title'		- the title of the item (HTML-encoded w/o tags)
// $templ	- array with the following entries:
//	'prefix'	- gets printed first
//	'postfix'	- gets printed finally
//	'separator'	- separates links
//	'item'		- format-strings for the corresponding item-types
//	'current_item'	  with %1$s for the URL and %2$s for the title

function menubench_menu($curkey, $items, $templ)
{
	print $templ['prefix'];

	$printsep = false;
	$sep = $templ['separator'];

	$fmt = $templ['item'];
	$curfmt = $templ['current_item'];

	foreach($items as $key => $item)
	{
		menubench_print_item($item,
			$curkey==$key ? $curfmt : $fmt, $printsep, $sep);
	}

	print $templ['postfix'];
}


?>
